/**
 * @file
 * Drupal behavior for the feadmin toolbar.
 *
 * Sponsored by: www.freelance-drupal.com
 */

(function (Drupal, $) {
  "use strict";

  Drupal.feaAdmin = Drupal.feaAdmin || {};

  /**
   * Drupal feadmin toolbar behavior.
   */
  Drupal.behaviors.feaAdminToolbar = {
    attach: function (context, settings) {
      if (!this.isInitialized) {
        this.isInitialized = true;

        // Init toolbar model.
        var toolbarModel = Drupal.feaAdmin.toolbar.models.toolbarModel = new Drupal.feaAdmin.toolbar.ToolbarModel();

        // Init toolbar view.
        var toolbar = document.getElementById('feadmin-toolbar');
        if (toolbar) {
          Drupal.feaAdmin.toolbar.views.toolbarVisualView = new Drupal.feaAdmin.toolbar.ToolbarVisualView({
            el: toolbar,
            model: toolbarModel
          });
        }

        // Init menu view.
        Drupal.feaAdmin.toolbar.views.menuVisualView = new Drupal.feaAdmin.toolbar.MenuVisualView({
          el: document.getElementsByClassName('js-feadmin-toogle'),
          model: toolbarModel
        });

        // Init body view.
        Drupal.feaAdmin.toolbar.views.bodyVisualView = new Drupal.feaAdmin.toolbar.BodyVisualView({
          model: toolbarModel
        });

        /*// Init toolbar model.
        var bodyModel = Drupal.feaAdmin.toolbar.models.bodyModel = new Drupal.feaAdmin.toolbar.BodyModel();

        // Init toolbar view.
        var toolbarItem = $('#feadmin-toolbar .toolbar-tray-content h3');
        if (toolbarItem) {
          Drupal.feaAdmin.toolbar.views.toolbarItemVisualView = new Drupal.feaAdmin.toolbar.ToolbarItemVisualView({
            el: toolbarItem,
            model: bodyModel
          });
        }*/
      }
    }
  };

  /**
   * feaAdmin toolbar Backbone objects.
   */
  Drupal.feaAdmin.toolbar = {
    // A hash of View instances.
    views: {},
    // A hash of Model instances.
    models: {}
  };

})(Drupal, jQuery);
